
#if !defined( gl_ase_h )
#define gl_ase_h

#include <stdlib.h>

//  This interface can issue geometry as found in an ASE file.
//  It is very, very primitive.
class I_GL_ASE {
  public:
    virtual void dispose() = 0;

    virtual bool normals() = 0;
    virtual bool texcoords() = 0;
    virtual bool colors() = 0;
    virtual unsigned int numMaterials() = 0;
    virtual unsigned int numVertices() = 0;
    virtual unsigned int numTriangles() = 0;
    virtual bool getMesh( float * vertices, uint numVertices, int * triangles, uint numTriangles ) = 0;
    //  "outLow" and "outHigh" are float[3] each. "outRadius" is scalar.
    virtual void getBounds( float * outLow, float * outHigh, float * outRadius ) = 0;
    virtual char const * materialNameAt( unsigned int ix ) = 0;
    virtual char const * materialDiffuseMapAt( unsigned int ix ) = 0;

    virtual void issue( unsigned int mtl ) = 0;
    virtual void issueAll() = 0;
};

I_GL_ASE * MakeGL_ASE( char const * name, char const * str, size_t len, float scale );

#endif  //  gl_ase_h

