
#if !defined( gl_text_h )
#define gl_text_h

#include "textures.h"
#include "image.h"
#include "glwrap.h" //  for GWColor

class GlText {
  public:
    void dispose();
    void clear();
    void fill( GWColor color, int x, int y, int width, int height );
    void drawText( GWColor color, int x, int y, char const * text, int len = -1 );
    void measureText( char const * text, int * ow, int * oh, int len = -1 );
    void drawLine( GWColor color, int x1, int y1, int x2, int y2 );
    TextureRef texture();
    void getImage( Image * oImage );
    void dirty();
    void scroll( GWColor color, int dx, int dy );
  private:
    friend GlText * MakeGlText( int width, int height );
    GlText( int width, int height );
    GlText( GlText const & );
    GlText & operator=( GlText const & );
    friend class GlTextImp;
    GlTextImp * imp_;
};

GlText * MakeGlText( int width, int height );

#endif  //  gl_text_h
