
#if !defined( glut_content_h )
#define glut_content_h


//  Is it great that there's both IGlutContent and I_GWWindow?
//  Answer: no.

class IGlutContent {
  public:
    //  implement this for your scene
    virtual void createScene() = 0;
    virtual void step( float deltaTime ) = 0;

    virtual void key( int x, int y, unsigned char key );
    virtual void special( int x, int y, int key, bool down );
    virtual void beginDrag( int x, int y, unsigned int buttons );
    virtual void dragMove( int x, int y );
    virtual void endDrag( int x, int y );
    virtual void mouseMove( int x, int y );

  protected:
    //  call these to affect the host
    void setDefaultKeyHandling( bool def );
    void setDefaultMouseCamera( bool def );
    void getCamera( float * outXyz, float * outLookAt, float * outHeading, float * outPitch );
    void setCamera( float const * xyz, float const heading, float pitch ); //  camera heading in degrees
    void setDefaultCameraSpeed( float s );
    void grabMouse( bool grabbed );
};

IGlutContent * MakeGlutContent();

#endif  //  glut_content_h
