
#if !defined( image_h )
#define image_h

#include "glut-start.h"

struct Image {
  Image() { width = height = bits = pitch = 0; base = toFree = 0; }
  ~Image();
  Image( Image const & o );
  Image & operator=( Image const & o );
  char const * name() const;
  void allocate( int bits, int width, int height );

  int width;
  int height;
  int bits;
  int pitch;
  void * base;

protected:
  friend bool loadTgaImage( char const * path, Image * oImage );
  friend bool loadDdsImage( char const * path, Image * oImage );
  void * toFree;
};

bool loadImage( char const * path, Image * outImage );

bool loadTgaImage( char const * path, Image * outImage );
bool saveTgaImage( char const * path, Image const * iImage );

bool loadDdsImage( char const * path, Image * outImage );


#endif  //  image_h


