
#section context

blend one one_minus_src_alpha
alphaTest disable
depthTest disable
depthWrite disable
color 0.6 0.6 0.6 0.7

#section defaults

noiseMap "media/multinoise.tga"

#section vertex-shader

uniform float s_time_3;
uniform float s_time_2;
uniform float s_time_1;

void main()
{
	gl_Position = ftransform();
	gl_TexCoord[0] = 
	      (gl_MultiTexCoord0 + vec4( 0.0, -s_time_3, 0.0, 0.0 )) * vec4( 2.0, 1.0, 1.0, 1.0 );
	gl_TexCoord[1] = 
	      (gl_MultiTexCoord0 + vec4( 0.0, -s_time_2, 0.0, 0.0 )) * vec4( 3.0, 1.0, 1.0, 1.0 );
  gl_TexCoord[2] = gl_MultiTexCoord0;
	gl_FrontColor = 
	    mix(
	        gl_Color,
	        vec4( 0.7, 0.5, 0.3, gl_Color.a ),
	        sin( s_time_1 * 6.2832 ) * 0.2 + 0.2 );
}

#section fragment-shader

uniform sampler2D noiseMap;

void main()
{
  float r = 
      texture2D( noiseMap, gl_TexCoord[0].xy ).r
      * (1.0 - gl_TexCoord[2].y);
  float y = 
      texture2D( noiseMap, gl_TexCoord[1].xy ).g
      * clamp(
          1.0 - 2.0 * gl_TexCoord[2].y,
          0.0,
          1.0 );

  vec4 color = vec4( 0.5*(r+y), r*y, 0.1*y, 1.0 );

	gl_FragColor = 
	    color * gl_Color;
}

