
//  This shader uses the road texture to color the dust, 
//	such that the dust particle system doesn't have to 
//	know about it.

#section context

blend one one
alphaTest GREATER 0.01
depthWrite disable

#section defaults

diffuseMap "media/missing.dds"
roadMap "roads"

#section vertex-shader

void main()
{
	gl_Position = ftransform();
	gl_FrontColor = gl_Color;
	gl_TexCoord[0] = gl_MultiTexCoord0;
}

#section fragment-shader

uniform sampler2D diffuseMap;
uniform sampler2D roadMap;

void main()
{
	vec4 color = vec4( 
			texture2D(
					roadMap,
					gl_TexCoord[0].xy ).rgb,
			texture2D(
					diffuseMap,
					gl_TexCoord[0].xy ).a );
	gl_FragColor = color * gl_Color;
}

