
varying vec4 g_FragPos;

#section context

color 1.0 1.0 1.0 1.0

#section defaults

diffuseMap "media/tanktreads.dds"
treadOffset 0

#section vertex-shader

//  Simple vertex shader that only assumes the varying gl_FragPos, 
//  and outputs enough for regular diffuse lighting. This version 
//  also offsets the texture "u" position based on treadOffset.

uniform float treadOffset;


void main()
{
  gl_Position = ftransform();
  g_FragPos = gl_Vertex;
  gl_TexCoord[0] = gl_MultiTexCoord0;
  gl_TexCoord[0].x += treadOffset;
  gl_FrontColor = gl_Color * (gl_LightSource[0].ambient + 
      gl_LightSource[0].diffuse * vec4( clamp( 
          dot( normalize( gl_NormalMatrix * gl_Normal ), 
               gl_LightSource[0].position.xyz ), 
          0.0, 
          1.0 ) ) );
}


#section fragment-shader "media/fs-1tex.glfs"

