
#if !defined( mycamera_h )
#define mycamera_h

#include "mysystem.h"

void CameraSpecialLook( double inTime, Vector3 const & at, Vector3 const & from );


class MyCamera : public MySystem {

  public:

    enum CameraShot {
      ChaseCam,
      FirstPersonIsh,
      SideCam,
      SpecialLook,
    };

    MyCamera();

    CameraShot desiredShot() const;
    void setDesiredShot( CameraShot shot );
    MySystem * focus() const;
    void setFocus( MySystem * focus );
    void setAim( float aim, float elevation );
    void parameters( Vector3 * lookFrom, Vector3 * lookAt, Vector3 * up ) const;
    bool physical();
    bool wantsContact( dContact & c, MySystemBase * other, dGeomID you, dGeomID him, bool firstTest );
    void preStep();
    void cutCamera();
    void postStep();
    void desiredFirstPersonCamera( Vector3 * pos, Vector3 * look, Vector3 * u ) const;
    void step( float delta );
    void preventCutForTime( float time ) { preventCutTime_ = time; }

private:

    Vector3 lastVel;
    float velChange;
    size_t lastCut;
    double lastCutTime;
    CameraShot desiredShot_;
    Vector3 firstPersonPos_;
    Vector3 firstPersonLookDir_;
    Vector3 firstPersonUp_;
    MySystem * focus_;
    float preventCutTime_;
    float aim_;
    float elevation_;

    Vector3 rotateLookFromAround( Vector3 const & from, float amt, Vector3 const & around, Vector3 const & up ) const;
};


#endif  //  mycamera_h

