

#include "mycrate.h"
#include "mytweakables.h"
#include "glshaderstate.h"
#include "gl-ase.h"


MyCrate::MyCrate( GLShader * crateShader, I_GL_ASE * crateMesh, float sx, float sy, float sz )
{
  dBodyID tempBody = dBodyCreate( world() );
  dMass m;
  dMassSetBoxTotal( &m, CRATE_MASS, sx, sy, sz );
  dBodySetMass( tempBody, &m );
  addBody( tempBody, crateShader, crateMesh );
  dGeomID g = dCreateBox( worldSpace(), sx, sy, sz );
  addGeom( g, tempBody );
  shader_ = crateShader;
}


void MyCrate::postStep()
{
  //  MyCrate
  MySystem::postStep();
}

void MyCrate::render()
{
  if( dBodyIsEnabled( bodies_[0].body ) ) {
    meshes_[0].shader->context().color = GLColor( 128, 255, 255, 255 );
  }
  else {
    meshes_[0].shader->context().color = GLColor( 255, 128, 128, 255 );
  }
  MySystem::render();
}

bool MyCrate::wantsContact( dContact & c, MySystemBase * other, dGeomID you, dGeomID him, bool firstTest )
{
  c.surface.slip1 = 0.1f;
  c.surface.slip2 = 0.1f;
  c.surface.mu = 1;
  c.surface.mu2 = 1;
  c.surface.mode |= dContactSlip1 | dContactSlip2 | dContactApprox1;
  return true;
}

