
#if !defined( mygrenade_h )
#define mygrenade_h

#include "myexplodable.h"
#include <vector>

//  This is public because I call MyGrenade::stepAll()/renderAll().
//  The class could be hidden once I have generic entity management.

class MyGrenade : public Explodable< MySystem > {
  public:
    MyGrenade( Vector3 const & pos, Matrix3 const & ori, Vector3 const & ptVel, GLShader * shader, I_GL_ASE * mesh );
    ~MyGrenade();
    void preStep();
    bool wantsContact( dContact & c, MySystemBase * other, dGeomID you, dGeomID him, bool firstTest );
    void postStep();

    static void preStepAll();
    static void postStepAll();
    static void renderAll();

    bool hasGeom( dGeomID geom ) const { return geoms_[0] == geom; }

    bool exploding_;
  protected:
    Vector3 oldPos_;
    static std::vector< MySystem * > grenades_;
};

class I_Weapon;

I_Weapon * NewGrenadeWeapon();

#endif
