
#include "myprop.h"


MyProp::MyProp()
{
  mesh_ = 0;
  posOri_ = Matrix4::Identity;
}

MyProp::MyProp( I_GL_ASE * ase, GLShader * shader, Matrix4 const & posOri, I_Scene * scene )
{
  init( ase, shader, posOri, scene );
}

void MyProp::init( I_GL_ASE * ase, GLShader * shader, Matrix4 const & posOri, I_Scene * scene )
{
  mesh_ = ase;
  shader_ = shader;
  posOri_ = posOri;
  ref_ = scene->addNode( this, posOri );
}

MyProp::~MyProp()
{
}

void MyProp::render() const
{
  glPushMatrix();
  glMultMatrixf( &posOri_.xx );
  shader_->apply();
  mesh_->issueAll();
  glPopMatrix();
  assert( !glGetError() );
}

//  properties() returns resting state properties -- i e, aabb at identity posOri
void MyProp::properties( Bounds * b, float * outRadius )
{
  mesh_->getBounds( &b->low.x, &b->high.x, outRadius );
}

