
#if !defined( myrocket_h )
#define myrocket_h

#include "mysystem.h"
#include "myparticles.h"
#include "myexplodable.h"


class MyRocket : public Explodable< MySystem > {
  public:
    MyRocket( Vector3 const & pos, Matrix3 const & ori, Vector3 const & ptVel, GLShader * shader, I_GL_ASE * model );
    ~MyRocket();

    void preStep();
    bool wantsContact( dContact & c, MySystemBase * other, dGeomID you, dGeomID him, bool firstTest );
    void postStep();
    bool hasGeom( dGeomID g ) { return g == geoms_[0]; }

    static void preStepAll();
    static void postStepAll();
    static void renderAll();

    bool exploding_;

  private:

    Vector3 oldPos_;
    float age_;
    MyParticles * smokeTrail_;
    static std::vector< MySystem * > rockets_;
};

class I_Weapon;

I_Weapon * NewRocketWeapon();


#endif  //  myrocket_h
