
#if !defined( mysystemsnapshot_h )
#define mysystemsnapshot_h

#include "MySystem.h"


class MySystemSnapshot {
  public:
    MySystemSnapshot()
      {
      }
    MySystemSnapshot( MySystem const & s )
      {
        capture( s );
      }
    ~MySystemSnapshot()
      {
      }
    void capture( MySystem const & s )
      {
        size_t c = s.bodyCount();
        xforms_.resize( c );
        for( size_t i = 0; i < c; ++i ) {
          Xform & x = xforms_[i];
          dBodyID b = s.bodyAt( i );
          x.rotation = *(Vector4 const *)dBodyGetQuaternion( b );
          x.position = *(Vector3 const *)dBodyGetPosition( b );
          x.avel = *(Vector3 const *)dBodyGetAngularVel( b );
          x.lvel = *(Vector3 const *)dBodyGetAngularVel( b );
        }
      }
    void restore( MySystem * s )
      {
        size_t c = s->bodyCount();
        if( xforms_.size() < c ) {
          c = xforms_.size();
        }
        for( size_t i = 0; i < c; ++i ) {
          Xform & x = xforms_[i];
          dBodyID b = s->bodyAt( i );
          dBodySetQuaternion( b, &x.rotation.x );
          dBodySetPosition( b, x.position.x, x.position.y, x.position.z );
          dBodySetAngularVel( b, x.avel.x, x.avel.y, x.avel.z );
          dBodySetLinearVel( b, x.lvel.x, x.lvel.y, x.lvel.z ); 
        }
      }
  private:
    struct Xform {
      Vector4 rotation;
      Vector3 position;
      Vector3 avel;
      Vector3 lvel;
    };
    std::vector< Xform > xforms_;
};

#endif  //  mysystemsnapshot_h
