
#if !defined( mytank_h )
#define mytank_h

#include "myvehicle.h"
#include "mysystemsnapshot.h"
#include <vector>

class I_Terrain;
class MyParticles;

class MyTank : public MyVehicle {
  public:
    struct Params {
      I_GL_ASE * body;
      I_Terrain * terrain;
    };
    MyTank( Params const & p );

    virtual void render();
    virtual void preStep();
    bool wantsContact( dContact & contact, MySystemBase * other, dGeomID you, dGeomID him, bool firstTest );
    virtual void postStep();

    virtual void recoverStep();
    virtual void jumpImpulse();
    virtual void setTurn( float turn );
    virtual void setGas( float gas, float target );
    virtual void setSwayBars( bool s ) {}
    virtual bool swayBars() const { return false; }
    virtual void setAim( float *, float * );

    virtual I_Weapon * weapon();
    virtual I_Weapon * weapon( Weapon w );
    virtual Weapon nextWeapon( int dir );
    virtual void setWeapon( Weapon w );

    bool hasGeom( dGeomID g );

  private:

    ~MyTank();

    float gas_;
    float turn_;
    float jumpForce_;
    bool still_;
    bool contact_;
    I_Terrain * terrain_;
    MyParticles * dust_[2];
    std::vector< GLShader * > materials_;
    float lTreadOffset_;
    uint lTread_;
    int lTreadParam_;
    float rTreadOffset_;
    uint rTread_;
    int rTreadParam_;
    dBodyID turretBody_;
    dBodyID gunBody_;
    uint turretPart_;
    uint gunPart_;
    uint launcherPart_;
    dJointID gunJoint_;
    dJointID turretJoint_;
    Vector3 turretDisplacement_;
    Vector3 gunDisplacement_;
    float elevation_;
    Weapon weapon_;
    I_Weapon * grenadeWeapon_;
    I_Weapon * rocketWeapon_;
    I_Weapon * mineWeapon_;

    MySystemSnapshot snapshot_;

    void rayCollTest( Vector3 const & v, Vector3 const & up, float * outForce );
    bool geomIsTreads( dGeomID you ) const;
};

#endif  //  mytank_h
