
#if !defined( mytweakables_h )
#define mytweakables_h

#include "tweakable.h"

TW_FLOAT(simulation,TIME_STEP,0.01f);
TW_FLOAT(simulation,CRATE_MASS,0.8f);
TW_FLOAT(simulation,PLANEBOTTOM,35);
TW_FLOAT(simulation,SURFACE_MU,20.0f);
TW_FLOAT(simulation,NUM_CRATES,78);
TW_FLOAT(simulation,FPS_OVERLAY,1);
TW_FLOAT(simulation,AUTO_DISABLE,1);
TW_FLOAT(simulation,AUTO_DISABLE_LINEAR,0.03f);
TW_FLOAT(simulation,AUTO_DISABLE_ANGULAR,0.04f);
TW_FLOAT(simulation,AUTO_DISABLE_STEPS,30);
TW_FLOAT(simulation,CAMERA_LOOKAHEAD,0.4f);
TW_FLOAT(simulation,CAMERA_DISTANCE_FORCE,8.0f);
TW_FLOAT(simulation,CAMERA_BACK,8);
TW_FLOAT(simulation,CAMERA_UP,3);
TW_FLOAT(simulation,MAX_CAMERA_DISTANCE_SQUARED,150);
TW_FLOAT(simulation,MAX_CAMERA_VEL_CHANGE,2000);
TW_FLOAT(simulation,CAMERA_CUT_INTERVAL,1.5f);

TW_FLOAT(terrain,TERRAIN_SCALE,0.5f);
TW_FLOAT(terrain,TERRAIN_OFFSET,-45);
TW_FLOAT(terrain,TERRAIN_TREES,100);

TW_FLOAT(weapons,RECOIL,0.10f);
TW_FLOAT(weapons,GRENADE_RADIUS,0.1f);
TW_FLOAT(weapons,GRENADE_EXPLODE_RADIUS,7);
TW_FLOAT(weapons,GRENADE_EXPLODE_FORCE,30);
TW_FLOAT(weapons,GRENADE_FORCE,(40/TIME_STEP));
TW_FLOAT(weapons,GRENADE_UP_FORCE,(3/TIME_STEP));
TW_FLOAT(weapons,GRENADE_REFIRE_TIME,0.5f);
TW_FLOAT(weapons,GRENADE_LAUNCHER_UP,1.5f);
TW_FLOAT(weapons,GRENADE_LAUNCHER_FRONT,3);
TW_FLOAT(weapons,GRENADE_LAUNCHER_LEFT,-0.5f);
TW_FLOAT(weapons,ROCKET_EXPLODE_RADIUS,10);
TW_FLOAT(weapons,ROCKET_EXPLODE_FORCE,25);
TW_FLOAT(weapons,ROCKET_SPEED,15);
TW_FLOAT(weapons,ROCKET_MAX_AGE,5);
TW_FLOAT(weapons,ROCKET_REFIRE_TIME,1.5f);
TW_FLOAT(weapons,ROCKET_FORCE,15);
TW_FLOAT(weapons,ROCKET_VOLUME,0.6f);
TW_FLOAT(weapons,ROCKET_LAUNCHER_UP,1.5f);
TW_FLOAT(weapons,ROCKET_LAUNCHER_FRONT,0);
TW_FLOAT(weapons,ROCKET_LAUNCHER_LEFT,0.7f);
TW_FLOAT(weapons,ROCKET_RADIUS,0.075f);
TW_FLOAT(weapons,ROCKET_LENGTH,0.2f);
TW_FLOAT(weapons,ROCKET_STABILIZE,1.0f);
TW_FLOAT(weapons,MINE_REFIRE_TIME,2);
TW_FLOAT(weapons,MINE_OFFSET_Y,-0.2f);
TW_FLOAT(weapons,MINE_FUSE_TIME,4.0f);
TW_FLOAT(weapons,MINE_RADIUS,20);
TW_FLOAT(weapons,MINE_EXPLODE_FORCE,40);
TW_FLOAT(weapons,MACHINEGUN_REFIRE_TIME,0.1f);
TW_FLOAT(weapons,MACHINEGUN_BULLET_FORCE,10.0f);

TW_FLOAT(car,WHEEL_RADIUS,0.42f);
TW_FLOAT(car,SINK_AMT,0.4f);
TW_FLOAT(car,WHEEL_LOW,0.4f);
TW_FLOAT(car,CHASSIS_MASS,8);
TW_FLOAT(car,WHEEL_MASS,0.3f);
TW_FLOAT(car,POWER,20);
TW_FLOAT(car,IDLE_POWER,2);
TW_FLOAT(car,BACK_POWER,17);
TW_FLOAT(car,MAX_FORWARD,46);
TW_FLOAT(car,GAS_INCREMENT,0.5f);
TW_FLOAT(car,GAS_DECREMENT,2.0f);
TW_FLOAT(car,GAS_COAST,1.0f);
TW_FLOAT(car,TURN_MAX,0.2f);
TW_FLOAT(car,TURN_INNER_SCALE,1.5f);
TW_FLOAT(car,TURN_INCREMENT,0.03f);
TW_FLOAT(car,TURN_COAST,0.05f);
TW_FLOAT(car,EJECT_FRONT,15);
TW_FLOAT(car,EJECT_UP,3);
TW_FLOAT(car,GRAB_RAY_LENGTH,15);
TW_FLOAT(car,GRAB_DESIRED_FRONT,4);
TW_FLOAT(car,GRAB_DESIRED_UP,1.5f);
TW_FLOAT(car,GRABBED_LOOKAHEAD,0.2f);
TW_FLOAT(car,GRABBED_FORCE,30);
TW_FLOAT(car,GRABBED_Y_OFFSET,0.3f);

TW_FLOAT(car,FRONT_SUSPENSION_ERP,0.15f);
TW_FLOAT(car,REAR_SUSPENSION_ERP,0.15f);
TW_FLOAT(car,FRONT_SUSPENSION_CFM,0.04f);
TW_FLOAT(car,REAR_SUSPENSION_CFM,0.04f);
TW_FLOAT(car,FRONT_TURN_ERP,0.99f);
TW_FLOAT(car,REAR_TURN_ERP,0.99f);
TW_FLOAT(car,FRONT_TURN_CFM,0.001f);
TW_FLOAT(car,REAR_TURN_CFM,0.001f);
TW_FLOAT(car,FRONTPCT,0.7f);
TW_FLOAT(car,REARPCT,0.7f);
TW_FLOAT(car,AERO_LOAD,-0.1f);
TW_FLOAT(car,SWAY_FORCE,300);
TW_FLOAT(car,TIRE_MU,3);
TW_FLOAT(car,TIRE_SLIP,0.003f);

#endif
