
#if !defined( myvehicle_h )
#define myvehicle_h

#include "mysystem.h"
#include "myweapon.h"

class MyVehicle : public MySystem {
  public:

    virtual void recoverStep() = 0;
    virtual void jumpImpulse() = 0;
    virtual void setTurn( float turn ) = 0;
    virtual void setGas( float gas, float target ) = 0;
    virtual void setSwayBars( bool s ) = 0;
    virtual bool swayBars() const = 0;
    virtual void setAim( float * aim, float * elevation ) = 0;

    //  This weapon handling could probably be factored
    virtual I_Weapon * weapon() = 0;
    virtual I_Weapon * weapon( Weapon w ) = 0;
    virtual Weapon nextWeapon( int dir ) = 0;
    virtual void setWeapon( Weapon w ) = 0;

    dBodyID chassisBody_;

  protected:
    virtual ~MyVehicle() {}
};


#endif  //  myvehicle_h
