
#if !defined( myweapon_h )
#define myweapon_h

#include "mymath.h"

enum Weapon {
  FirstWeapon,
  GrenadeWeapon = FirstWeapon,
  RocketWeapon,
  MineWeapon,
  MachinegunWeapon,
  NumWeapons,
  NullWeapon = NumWeapons
};

class I_Weapon {
  public:
    virtual void renderSight( float screenWidth, float screenHeight, Matrix4 const & camMtx, Matrix4 const & projMtx ) = 0;
    virtual void setAim( Matrix3 const & aim, Vector3 const & source, Vector3 const & ptVel ) = 0;
    virtual bool readyToFire( double time ) = 0;
    virtual bool fire( double time ) = 0;
    virtual void renderIndicators( float phi, float alpha ) = 0;
    virtual bool autoFire() { return false; }
};


#endif  //  myweapon_h
