
#if !defined( scratch_h )
#define scratch_h

#include "glut-start.h"

//  You can create an instance of Scratch on the stack, and allocate 
//  successive pointers for up to ScratchSizeMax bytes out of it. 
//  The total amount of scratch available is ScratchSizeMax, and there 
//  may be less available because some has been allocated.

enum {
  ScratchSizeMax = 4 * 1024 * 1024 + 256
};

class StackScratch
{
  //  unimplemented
  void * operator new( size_t );
  void operator delete( void * );
  StackScratch( StackScratch const & other );
  StackScratch & operator=( StackScratch const & );
  long mTotal;
public:
  //  only create me on the stack!
  StackScratch( );
  ~StackScratch( );
  void * get( long size );
};

#endif  //  scratch_h

