
#if !defined( soundmanager_h )
#define soundmanager_h


typedef struct SoundInstance * SoundHandle;
typedef struct PlayingSound * PlayingHandle;

struct PlayParameters {
  float volL;
  float volR;
  //float muffle;
  float pitch;
  bool looping;     //  you can't be both looping and autoStop
  bool autoStop;    //  if it's auto-stop, you should not stopPlaying() it, nor attempt to control it
};

class SoundManager {
  public:
    virtual void dispose() = 0;
    virtual SoundHandle loadSound( char const * path ) = 0;
    virtual void unloadSound( SoundHandle h ) = 0;
    //  not looping means autoStop in this function
    virtual PlayingHandle playInstance( SoundHandle h, float volume ) = 0;
    virtual PlayingHandle playInstance( SoundHandle h, PlayParameters const * p ) = 0;
    virtual void stopPlaying( PlayingHandle h ) = 0;
    virtual void setVolume( PlayingHandle h, float volL, float volR ) = 0;
    virtual void setVolume( float mainVolume ) = 0;
    virtual void setPitch( PlayingHandle h, float relative ) = 0;
    //virtual void setMuffle( PlayingHandle h, float muffle ) = 0;      //  0 == off, 1 == fully muffled
};

SoundManager * NewSoundManager();

#endif    //  soundmanager_h
