
#if !defined( textures_h )
#define textures_h

#include <GL/GL.h>
#include "glut-start.h"

class InternalTexture;

class TextureRef
{
public:
  TextureRef( );
  TextureRef( int texture, GLenum target );
  TextureRef( char const * path, bool mipmaps = true );
  ~TextureRef( );
  TextureRef( TextureRef const & other );
  TextureRef & operator=( TextureRef const & other );

  bool operator==( TextureRef const & other ) const
            {
              return mTexture == other.mTexture;
            }
  bool operator!=( TextureRef const & other ) const
            {
              return !(mTexture == other.mTexture);
            }
  bool operator<( TextureRef const & other ) const;
  bool consistent( ) const;

  void getSize( int * xSize, int * ySize );
  void getInset( float * xInset, float * yInset );
  bool clamp() const;
  void setClamp( bool clamp );

  static TextureRef null;
  static TextureRef nullCube;

  GLuint textureIdHack() const;
  GLenum textureTargetHack() const;

private:
  friend class InternalTexture;
  InternalTexture * mTexture;
};



#endif  //  textures_h
