
#if !defined( tweakable_h )
#define tweakable_h


class TweakableFloat;
extern "C" void doSaveTweakableManager();

class TweakableManager {
  public:
    TweakableManager();
    void saveAll();
  protected:
    friend class TweakableFloat;
    friend void doSaveTweakableManager();
    enum Type {
      Init,
      Float,
    };
    struct Variable {
      char name_[32];
      Type type_;
      union {
        float float_;
      };
      Variable * next_;
    };
    struct File {
      char name_[32];
      Variable * vars_;
      File * next_;
    };
    File * files_;
    void registerFloat( char const * file, char const * name, float def, TweakableFloat * tf );
    Variable * makeVar( char const * file, char const * name );
    void readFileVars( File * f );
  private:
    static TweakableManager & manager();
};

class TweakableFloat {
  public:
    TweakableFloat( char const * f, char const * n, float def )
      {
        TweakableManager::manager().registerFloat( f, n, def, this );
      }
    operator float() const
      {
        return var_->float_;
      }
    float & operator=( float f )
      {
        var_->float_ = f;
        return var_->float_;
      }
  private:
    friend class TweakableManager;
    TweakableManager::Variable * var_;
};


#define TW_FLOAT(f,n,v) \
  static TweakableFloat n( #f, #n, v )

#endif  //  tweakable_h
